#include <stdio.h>
#include <windows.h>
#include <locale.h>

int getLogicalDriveStrings() {
    printf("- GetLogicalDriveStrings:\n");
    char buffer[4096]; //    
    DWORD bufSize = sizeof(buffer) - 1; //  ,       

    GetLogicalDriveStrings(bufSize, buffer); //    
    char *drive = buffer;
    while (*drive) { //  
        printf(": %s\n", drive);
        //  
        drive += strlen(drive) + 1;
    }
    return 0;
}
int getVolumeInformation() {
    printf("- GetVolumeInformation:\n");
    char volumeName[256];
    char fileSystemName[256];
    DWORD serialNumber;
    DWORD maxComponentLength;
    DWORD fileSystemFlags;

    //     
    GetVolumeInformation("C:\\", //    ,    
                         volumeName, // ,    
                         sizeof(volumeName), //     
                         &serialNumber,  //   ,     
                         &maxComponentLength, //
                         &fileSystemFlags, //
                         fileSystemName, //     
                         sizeof(fileSystemName)); //     
    printf(" : %s\n", volumeName);
    printf(" : %lu\n", serialNumber);
    printf("Max Component Length: %lu\n", maxComponentLength);
    printf("  : %s\n", fileSystemName);
    printf("File System Flags: %lu\n", fileSystemFlags);
    return 0;
}

// ---
long getFileSize() {
    printf("- GetFileSize:\n");
    HANDLE hFile;
    DWORD fileSize;
    unsigned long structLargeInt;
    //  
    hFile = CreateFile((LPCSTR) "../text.txt",
                       GENERIC_READ,
                       FILE_SHARE_READ,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       NULL);

    //   
    structLargeInt = GetFileSize(hFile, NULL);

    //  
    CloseHandle(hFile);

    //   
    printf(" : %lu \n", structLargeInt);
    return 0;
}
int findNextFile() {
    printf("- FindNextFile:\n");
    WIN32_FIND_DATA findData;
    HANDLE hFind;
    char path[MAX_PATH];

    //    ,   
    strcpy(path, "..\\*");

    //    /  
    hFind = FindFirstFile(path, &findData);

    //       
    do {
        if (findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
            printf(": %s\n", findData.cFileName);
        } else {
            printf("\t: %s\n", findData.cFileName);
        }
    } while (FindNextFile(hFind, &findData));

    //   
    FindClose(hFind);

    return 0;
}
int getWindowsDirectory() {
    printf("- GetWindowsDirectory:\n");
    char windowsDir[255]; //    

    GetWindowsDirectory(windowsDir, sizeof(windowsDir));

    printf("  : %s\n", windowsDir);
    return 0;
}
int compareFileTime()  {
    printf("- CompareFileTime:\n");
    FILETIME fileTime1;
    FILETIME fileTime2;

    //  
    HANDLE file1 =  CreateFile((LPCSTR) "../text.txt",
                               GENERIC_READ,
                               FILE_SHARE_READ,
                               NULL,
                               OPEN_EXISTING,
                               FILE_ATTRIBUTE_NORMAL,
                               NULL);

    //    
    GetFileTime(file1, NULL, NULL, &fileTime1);

    //   
    CloseHandle(file1);

    //   
    HANDLE file2 =  CreateFile((LPCSTR) "../text2.txt",
                               GENERIC_READ,
                               FILE_SHARE_READ,
                               NULL,
                               OPEN_EXISTING,
                               FILE_ATTRIBUTE_NORMAL,
                               NULL);
    //     
    GetFileTime(file2, NULL, NULL, &fileTime2);

    //   
    CloseHandle(file2);

    //    
    int comparisonResult = CompareFileTime(&fileTime1, &fileTime2);

    if (comparisonResult == 1) {
        printf(" 1     2\n");
    } else if (comparisonResult == -1) {
        printf(" 2     1\n");
    } else {
        printf("   \n");
    }

    return 0;
}

// ---
int setLocalTime() {
    printf("- SetLocalTime:\n");
    //   SYSTEMTIME   
    SYSTEMTIME systemTime;

    //   SYSTEMTIME   
    GetLocalTime(&systemTime);
    printf("\n    : %02d-%02d-%d %02d:%02d:%02d\n",
           systemTime.wDay, systemTime.wMonth, systemTime.wYear,
           systemTime.wHour, systemTime.wMinute, systemTime.wSecond);

    //     1
    if (systemTime.wHour < 23) {
        systemTime.wHour++;
    } else {
        systemTime.wHour = 0;
    }

    //      SetLocalTime
    SetLocalTime(&systemTime);
    printf("  \n");

    printf("\n    : %02d-%02d-%d %02d:%02d:%02d\n",
           systemTime.wDay, systemTime.wMonth, systemTime.wYear,
           systemTime.wHour, systemTime.wMinute, systemTime.wSecond);

    return 0;
}
int setFileAttributes() {

    printf("- SetFileAttributes:\n");
// G  
    LPCWSTR filePath = L"..\\text3.txt";
    //   
    SetFileAttributes((LPCSTR) filePath, (DWORD) NULL);
    //   
    DWORD fileAttributes = GetFileAttributes((LPCSTR) filePath);
    printf("\t    : ");
    if (fileAttributes & FILE_ATTRIBUTE_READONLY) {
        printf("\n- Read-only");
    }
    if (fileAttributes & FILE_ATTRIBUTE_HIDDEN) {
        printf("\n- Hidden");
    }
    if (fileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
        printf("\n- Directory");
    }//       ...
    printf("\n");

    //   
    DWORD newFileAttributes = FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_DIRECTORY |fileAttributes;
    BOOL result = SetFileAttributes((LPCSTR) filePath, (DWORD) newFileAttributes);

    fileAttributes = GetFileAttributes((LPCSTR) filePath);

    printf("\t    : ");
    if (fileAttributes & FILE_ATTRIBUTE_READONLY) {
        printf("\n- Read-only");
    }
    if (fileAttributes & FILE_ATTRIBUTE_HIDDEN) {
        printf("\n- Hidden");
    }
    if (fileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
        printf("\n- Directory");
    }//       ...
    printf("\n");

    return 0;
}
int createFile() {
    printf("- CreateFile:\n");
    HANDLE hFile;
    char* fileName = "example.txt";

    //  
    hFile = CreateFile(fileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

    //   
    char* data = "Hello, World!";
    DWORD bytesWritten;
    WriteFile(hFile, data, strlen(data), &bytesWritten, NULL);

    //  
    CloseHandle(hFile);

    //   
    hFile = CreateFile(fileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

    //   
    const int bufferSize = 100;
    char buffer[bufferSize];
    DWORD bytesRead;
    if (!ReadFile(hFile, buffer, bufferSize, &bytesRead, NULL))
    {
        printf("Failed to read from file.\n");
        CloseHandle(hFile);
        return 1;
    }

    //   
    printf(" : %.*s\n", bytesRead, buffer);

    //  
    CloseHandle(hFile);

    return 0;
}
void copyFile(const char* sourceFile, const char* destinationFile) {
    printf("- CopyFile:\n");

    FILE* source = fopen(sourceFile, "rb");
    FILE* destination = fopen(destinationFile, "wb");

    //   
    char buffer[1024];
    size_t bytesRead;
    while ((bytesRead = fread(buffer, 1, sizeof(buffer), source)) > 0) {
        fwrite(buffer, 1, bytesRead, destination);
    }

    //  
    fclose(source);
    fclose(destination);

    printf("  .\n");
}



int main() {
    setlocale(LC_ALL, "Rus");
    printf("\n----------------------------\n");
    printf("\t  :\n");
    // getLogicalDriveStrings();// +   
    // getVolumeInformation();// +        
    printf("\n------------------------------------------\n");
    printf("\t    :\n");
    // getFileSize();// +   
    // findNextFile();// +      
    // getWindowsDirectory();// +     
    // compareFileTime();// +      
    printf("\n----------------------------\n");
    printf("\t :\n");
    // setLocalTime();// +     
    // setFileAttributes();// +   
    // createFile();// / 
    const char* sourceFile = ".//text.txt";
    const char* destinationFile = ".//text33.txt";
    CopyFile(".//text.txt", ".//text3.txt", 0);//  
}
